## netsniff-ng 0.5.4.1

=== src/Makefile ===
#
# Makefile for netsniff-ng
#

#
# Note: 
#   check_packets is not a main program, it is just an 
#   example implementation for a unix domain socket (uds) client.
#   Therefore, you explicitly need to build it for usage.
#   Possibly with newer version the uds API might have changed,
#   so a few manual adoptions could be possible.
#

CC               = gcc
# Use this for code analysis
#CC               = nccgen -ncgcc -ncld -ncfabs
LIBS             = -lpthread -lrt
INCLUDE          = -Iinclude
CFLAGS           = -Wall -O2

BUILD_FOLDERS    = lib

NAME             = netsniff-ng
OBJECTS          = netsniff-ng.o

BINDIR           = sbin
ETCDIR           = etc
MANDIR           = usr/share/man/man8
MANDIR_LOCAL     = doc

all: clean netsniff-ng

netsniff-ng: $(OBJECTS)
	$(CC) -o $(NAME) $(OBJECTS) $(shell find $(BUILD_FOLDERS) -name "*.o") $(LIBS)

%.o: %.c
	-for d in $(BUILD_FOLDERS); do (cd $$d; $(MAKE) $(MFLAGS) all); done
	$(CC) -c $(CFLAGS) $(INCLUDE) $<

install:
	install -D $(NAME) $(DESTDIR)/$(BINDIR)/$(NAME)
	install -d $(DESTDIR)/$(ETCDIR)/$(NAME)
	cp -r rules/ $(DESTDIR)/$(ETCDIR)/$(NAME)/
	cat $(MANDIR_LOCAL)/$(NAME).8 | gzip --best > $(MANDIR_LOCAL)/$(NAME).8.gz
	install -D $(MANDIR_LOCAL)/$(NAME).8.gz $(DESTDIR)/$(MANDIR)/$(NAME).8.gz

clean:
	-for d in $(BUILD_FOLDERS); do (cd $$d; $(MAKE) $(MFLAGS) clean); done
	rm *.o *.nccout Code.map $(NAME) $(MANDIR_LOCAL)/$(NAME).8.gz || true

uninstall:
	rm $(DESTDIR)/$(BINDIR)/$(NAME) || true
	rm -rf $(DESTDIR)/$(ETCDIR)/$(NAME) || true
	rm $(DESTDIR)/$(MANDIR)/$(NAME).8.gz || true

indent:
	$(PWD)/indent_code

=== src/lib/Makefile ===
#
# Makefile for netsniff-ng lib
#

CC               = gcc
# Use this for code analysis
#CC               = nccgen -ncgcc -ncld -ncfabs
LIBS             = -lpthread -lrt
INCLUDE          = -I../include
CFLAGS           = -Wall -O2

OBJECTS          = bpf_code.o export.o misc.o print.o rx_ring.o system.o

all: lib

lib: $(OBJECTS)

%.o: %.c
	$(CC) -c $(CFLAGS) $(INCLUDE) $<

clean:
	rm *.o *.nccout Code.map || true

## netsniff-ng 0.5.4.2

=== src/Makefile ===
--- 
+++ 
@@ -23,7 +23,7 @@
 NAME             = netsniff-ng
 OBJECTS          = netsniff-ng.o
 
-BINDIR           = sbin
+BINDIR           = usr/sbin
 ETCDIR           = etc
 MANDIR           = usr/share/man/man8
 MANDIR_LOCAL     = doc

=== src/lib/Makefile ===
--- 
+++ 
@@ -9,7 +9,7 @@
 INCLUDE          = -I../include
 CFLAGS           = -Wall -O2
 
-OBJECTS          = bpf_code.o export.o misc.o print.o rx_ring.o system.o
+OBJECTS          = bpf.o export.o misc.o print.o rx_ring.o system.o
 
 all: lib

## netsniff-ng 0.5.5.0

=== src/Makefile ===
#
# Makefile for netsniff-ng main
#

include definitions.mk

INCLUDE    = -Iinclude

core-objs  = netsniff-ng.o
lib-objs   = bpf.o misc.o print.o config.o rx_ring.o system.o dump.o hash.o \
	     netdev.o tx_ring.o bootstrap.o replay.o cursor.o xmalloc.o     \
	     strlcpy.o

target     = netsniff-ng

all: clean build
debug: all
develop: all

#-----------------------------------------------------------------------------

build: $(lib-objs) $(core-objs)
	@$(LD) $(target) $(core-objs) $(lib-objs) $(LIBS)

#-----------------------------------------------------------------------------

%.o: %.c
	@$(CC) $(CFLAGS) $(INCLUDE) $<

#-----------------------------------------------------------------------------

clean:
	@rm *.o *.tu *.nccout *~ Code.map $(target) \
	$(MANDIR_LOCAL)/$(target).8.gz > /dev/null 2>&1 || true

#-----------------------------------------------------------------------------

install:
	@install -D $(target) $(DESTDIR)/$(BINDIR)/$(target)
	@install -d $(DESTDIR)/$(ETCDIR)/$(target)/rules
	@cp -r rules/*.bpf $(DESTDIR)/$(ETCDIR)/$(target)/rules/
	@cat $(MANDIR_LOCAL)/$(target).8 | gzip --best > \
	$(MANDIR_LOCAL)/$(target).8.gz
	@install -D $(MANDIR_LOCAL)/$(target).8.gz \
	$(DESTDIR)/$(MANDIR)/$(target).8.gz

uninstall:
	@rm $(DESTDIR)/$(BINDIR)/$(target) || true
	@rm -rf $(DESTDIR)/$(ETCDIR)/$(target) || true
	@rm $(DESTDIR)/$(MANDIR)/$(target).8.gz || true

#-----------------------------------------------------------------------------

indent:
	$(PWD)/../scripts/indent_code .

help:
	@echo 'Cleaning targets:'
	@echo '  clean           - Remove generated files'
	@echo 'Building targets:'
	@echo '  all             - Build netsniff-ng (default)'
	@echo '  debug           - Build netsniff-ng for debugging _only_'
	@echo '  develop         - Build netsniff-ng for developing _only_'
	@echo 'Setup targets:'
	@echo '  install         - Install netsniff-ng'
	@echo '  uninstall       - Uninstall netsniff-ng'
	@echo 'Other targets:'
	@echo '  help            - Print this help'

=== debian/changelog ===
netsniff-ng (0.5.5.0-3) unstable; urgency=low

  * debian/control:
    + Updated Standards-Version to 3.9.2
    + Fixed short description synopsis
  * debian/copyright:
    + Updated for DEP-5 format specification
  * Added patch to fix spelling mistake in manpage

 -- Kartik Mistry <kartik@debian.org>  Mon, 30 May 2011 08:49:15 +0530

netsniff-ng (0.5.5.0-2) unstable; urgency=low

  * Upload to unstable
  * debian/control:
    + Added armhf support, closes wishlist bug. Closes: #604540
    + Excluded non-linux systems in architectures
    + Added Kartik as Uploader

 -- Daniel Borkmann <danborkmann@googlemail.com>  Mon, 07 Feb 2011 16:26:17 +0200

netsniff-ng (0.5.5.0-1) unstable; urgency=low

  * New upstream release
  * debian/control:
    + Updated to new standards version 3.9.1
    + Updated description
  * debian/watch:
    + Updated URL to public directory of netsniff-ngs website
  * Switch to dpkg-source 3.0 (quilt) format

 -- Daniel Borkmann <danborkmann@googlemail.com>  Sun, 10 Oct 2010 12:57:11 +0200

netsniff-ng (0.5.4.2-1) unstable; urgency=low

  * Another minor upstream release with fixes within the ring traversal
    method (packet look-ahead on the receive ring) and some basic BPF 
    filter check.
  * Changed installation path from /sbin into /usr/sbin
  * debian/control:
    + Updated to new standards version 3.8.4
    + Added ${misc:Depends} in order to fix the 'debhelper-but-no-misc-depends' 
      warning

 -- Daniel Borkmann <danborkmann@googlemail.com>  Sun, 14 Feb 2010 13:58:40 +0200

netsniff-ng (0.5.4.1-1) unstable; urgency=medium

  * New (minor) upstream release with security fix in netsniff-ng.c:
    A memset with a 4 Byte length overhead on 32-Bit systems could 
    run into a possible buffer overflow. Relevant sections have been fixed.
  * debian/control:
    + Changed architecture, because netsniff-ng is not written for 
      non-linux archs as kfreebsd-*

 -- Daniel Borkmann <danborkmann@googlemail.com>  Sat, 02 Jan 2010 11:18:03 +0200

netsniff-ng (0.5.4.0-1) unstable; urgency=low

  * New upstream release
  * debian/control:
    + Corrected package description
  * debian/watchfile:
    + Changed URL to watch for, because the googlecode site denies access, 
      mirrored tarball archive at htwk-leipzig.de

 -- Daniel Borkmann <danborkmann@googlemail.com>  Fri, 01 Jan 2010 19:07:23 +0200

netsniff-ng (0.5.3.1-1) unstable; urgency=low

  * Initial release for Debian, closes ITP bug. Closes: #561528

 -- Daniel Borkmann <danborkmann@googlemail.com>  Thu, 17 Dec 2009 22:55:51 +0200

=== debian/control ===
Source: netsniff-ng
Section: net
Priority: optional
Maintainer: Daniel Borkmann <danborkmann@googlemail.com>
Uploaders: Kartik Mistry <kartik@debian.org>
Standards-Version: 3.9.2
Build-Depends: debhelper (>= 7)
Homepage: http://www.netsniff-ng.org/

Package: netsniff-ng
Architecture: linux-any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: packet sniffing beast
 netsniff-ng is a high performance Linux network sniffer for packet inspection.
 It can be used for protocol analysis, reverse engineering or network
 debugging. The gain of performance is reached by 'zero-copy' mechanisms, so
 that the kernel does not need to copy packets from kernelspace to userspace.

=== debian/rules ===
#!/usr/bin/make -f
#
# debian/rules for netsniff-ng
# by Daniel Borkmann

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

build: build-stamp
build-stamp:
	dh_testdir
	cd src; $(MAKE) DESTDIR=$(CURDIR)/debian/netsniff-ng all
	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp
	cd src; $(MAKE) clean
	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs
	cd src; $(MAKE) install DESTDIR=$(CURDIR)/debian/netsniff-ng

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installdocs
	dh_installexamples
	dh_installchangelogs
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-arch binary-indep
.PHONY: build clean binary-indep binary-arch binary install

## netsniff-ng 0.5.7

=== src/CMakeLists.txt ===
PROJECT(netsniff-ng-toolkit C)

CMAKE_MINIMUM_REQUIRED(VERSION 2.6)

SET(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/modules)
SET(EXECUTABLE_INSTALL_PATH /usr/sbin)
SET(CONFIG_INSTALL_PATH /etc/netsniff-ng)

SET(VERSION "0.5.7")

INCLUDE(CheckBPFAttach)
INCLUDE(CheckPFPacket)
INCLUDE(CheckStrictAlign)
INCLUDE(CheckTxRing)
INCLUDE(Pod2Man)

ADD_DEFINITIONS(
	-O3
	-fstack-protector
	-fpie
	-std=gnu99
	-fno-strict-aliasing
	-D_FORTIFY_SOURCE=2
	-D_REENTRANT
	-march=native
	-mtune=native
	-Wall
	-Wundef
	-Wstrict-prototypes
	-Werror-implicit-function-declaration
	-Wformat=2
	-Wcomments
	-Wendif-labels
	-Wuninitialized
	-Winit-self
	-Wstrict-overflow=1
	-Wtype-limits
	-Wmissing-parameter-type
	-Wclobbered
	-Wempty-body
	-Wignored-qualifiers
	-Wmissing-include-dirs
	-Woverlength-strings
	-Wmissing-field-initializers
	-Wmissing-declarations
	-Wmissing-prototypes
	-Wlogical-op
	-Woverride-init
	-Wnested-externs
	-Wredundant-decls
	-Winvalid-pch
	-Wdisabled-optimization
	-Wstack-protector
	-Waggregate-return
	-Wcast-align
	-Wunsafe-loop-optimizations
	-Wfloat-equal
	-Wunknown-pragmas
	-Wunused-function
)

IF (CMAKE_BUILD_TYPE STREQUAL profile)
	ADD_DEFINITIONS(-g -pg)
ENDIF (CMAKE_BUILD_TYPE STREQUAL profile)

ENABLE_TESTING()

ADD_MANPAGE_TARGET()

INCLUDE_DIRECTORIES(.)

ADD_SUBDIRECTORY(netsniff-ng)
ADD_SUBDIRECTORY(ifpps)
ADD_SUBDIRECTORY(trafgen)
ADD_SUBDIRECTORY(bpfc)
ADD_SUBDIRECTORY(ashunt)
ADD_SUBDIRECTORY(curvetun)
ADD_SUBDIRECTORY(flowtop)

=== src/ashunt/CMakeLists.txt ===
PROJECT(ashunt C)

SET(BUILD_STRING "generic")

FIND_PACKAGE(LibGeoIP)
FIND_PACKAGE(Threads)
INCLUDE(Pod2Man)

IF (LIBGEOIP_FOUND AND CMAKE_HAVE_PTHREAD_CREATE)
	ADD_EXECUTABLE(${PROJECT_NAME}	../xmalloc.c
					../xio.c
					../xutils.c
					../proto_none.c
					../tprintf.c
					../aslookup.c
					../bpf.c
					../mtrand.c
					../ring_rx.c
					../ashunt.c)
	ADD_DEFINITIONS(-DPROGNAME_STRING="${PROJECT_NAME}"
			-DVERSION_STRING="${VERSION}"
			-DBUILD_STRING="${BUILD_STRING}")
	TARGET_LINK_LIBRARIES(ashunt ${LIBGEOIP_LIBRARY} ${CMAKE_THREAD_LIBS_INIT})
	POD2MAN(${CMAKE_SOURCE_DIR}/ashunt.c ashunt 8)
	INSTALL(TARGETS ${PROJECT_NAME} DESTINATION ${EXECUTABLE_INSTALL_PATH})
	INSTALL(FILES ../conf/whois.conf DESTINATION ${CONFIG_INSTALL_PATH})
ELSE (LIBGEOIP_FOUND AND CMAKE_HAVE_PTHREAD_CREATE)
	MESSAGE("libgeoip is missing on target. Skipping ${PROJECT_NAME} build.")
ENDIF (LIBGEOIP_FOUND AND CMAKE_HAVE_PTHREAD_CREATE)

=== src/bpfc/CMakeLists.txt ===
PROJECT(bpfc C)

SET(BUILD_STRING "generic")

FIND_PACKAGE(FLEX)
FIND_PACKAGE(BISON)
INCLUDE(Pod2Man)

IF (FLEX_FOUND AND BISON_FOUND)
	FLEX_TARGET(BPF_LEXER ../bpf_lexer.l ${CMAKE_CURRENT_BINARY_DIR}/bpfc_lex.yy.c)
	BISON_TARGET(BPF_PARSER ../bpf_parser.y ${CMAKE_CURRENT_BINARY_DIR}/bpf_parser.tab.c)
	ADD_EXECUTABLE(${PROJECT_NAME} 	../xmalloc.c
					../xutils.c
					../bpf.c
					${FLEX_BPF_LEXER_OUTPUTS}
					${BISON_BPF_PARSER_OUTPUT_SOURCE}
					../bpfc.c)
	ADD_DEFINITIONS(-DPROGNAME_STRING="${PROJECT_NAME}"
			-DVERSION_STRING="${VERSION}"
			-DBUILD_STRING="${BUILD_STRING}")
	POD2MAN(${CMAKE_SOURCE_DIR}/bpfc.c bpfc 8)
	INSTALL(TARGETS ${PROJECT_NAME} DESTINATION ${EXECUTABLE_INSTALL_PATH})
ELSE (FLEX_FOUND AND BISON_FOUND)
	MESSAGE("either flex or bison is missing on target. Skipping ${PROJECT_NAME} build.")
ENDIF (FLEX_FOUND AND BISON_FOUND)

=== src/curvetun/CMakeLists.txt ===
PROJECT(curvetun C)

SET(BUILD_STRING "generic")

INCLUDE(nacl_path.cmake OPTIONAL)

FIND_PACKAGE(Threads)
FIND_PACKAGE(LibNaCl)

IF (NACL_FOUND AND CMAKE_THREAD_LIBS_INIT)
	ADD_EXECUTABLE(${PROJECT_NAME}	../xmalloc.c
					../xio.c
					../xutils.c
					../stun.c
					../mtrand.c
					../patricia.c
					../trie.c
					../hash.c
					../curve.c
					../ct_cpusched.c
					../ct_usermgmt.c
					../ct_servmgmt.c
					../ct_server.c
					../ct_client.c
					../curvetun.c)
	ADD_DEFINITIONS(-DPROGNAME_STRING="${PROJECT_NAME}"
			-DVERSION_STRING="${VERSION}"
			-DBUILD_STRING="${BUILD_STRING}")
	INCLUDE_DIRECTORIES(${NACL_INCLUDE_DIR})
	TARGET_LINK_LIBRARIES(curvetun ${NACL_LIBRARY} ${CMAKE_THREAD_LIBS_INIT})
	POD2MAN(${CMAKE_SOURCE_DIR}/curvetun.c curvetun 8)
	INSTALL(TARGETS ${PROJECT_NAME} DESTINATION ${EXECUTABLE_INSTALL_PATH})
ELSE (NACL_FOUND AND CMAKE_THREAD_LIBS_INIT)
	MESSAGE("NaCl was not found. Check if NACL_INCLUDE_DIR and NACL_LIB_DIR are properly set in nacl_path.cmake. Skipping ${PROJECT_NAME} build")
ENDIF (NACL_FOUND AND CMAKE_THREAD_LIBS_INIT)

=== src/flowtop/CMakeLists.txt ===
PROJECT(flowtop C)

SET(BUILD_STRING "generic")

FIND_PACKAGE(LibGeoIP)
FIND_PACKAGE(Threads)
FIND_PACKAGE(Curses)
FIND_PACKAGE(LibNetFilterConnTrack)
FIND_PACKAGE(LibURCU)
INCLUDE(Pod2Man)

IF(CURSES_FOUND AND CMAKE_HAVE_PTHREAD_CREATE AND LIBGEOIP_FOUND AND LIBNETFILTER_CONNTRACK_FOUND AND LIBURCU_FOUND)
	ADD_EXECUTABLE(${PROJECT_NAME}	../xmalloc.c
					../oui.c
					../xio.c
					../xutils.c
					../hash.c
					../dissector_eth.c
					../dissector_80211.c
					../dissector.c
					../proto_none.c
					../tprintf.c
					../flowtop.c)
	ADD_DEFINITIONS(-DPROGNAME_STRING="${PROJECT_NAME}"
			-DVERSION_STRING="${VERSION}"
			-DBUILD_STRING="${BUILD_STRING}")
	TARGET_LINK_LIBRARIES(flowtop ${CURSES_NCURSES_LIBRARY} ${CMAKE_THREAD_LIBS_INIT} ${LIBNETFILTER_CONNTRACK_LIBRARY} ${LIBGEOIP_LIBRARY} ${LIBURCU_LIBRARY})
	POD2MAN(${CMAKE_SOURCE_DIR}/flowtop.c flowtop 8)
	INSTALL(TARGETS ${PROJECT_NAME} DESTINATION ${EXECUTABLE_INSTALL_PATH})
	INSTALL(FILES 	../conf/oui.conf
			../conf/udp.conf
			../conf/tcp.conf
			../conf/ether.conf
		DESTINATION ${CONFIG_INSTALL_PATH})
ELSE(CURSES_FOUND AND CMAKE_HAVE_PTHREAD_CREATE AND LIBGEOIP_FOUND AND LIBNETFILTER_CONNTRACK_FOUND AND LIBURCU_FOUND)
	MESSAGE("Either ncurses, pthread, libGeoIP, liburcu or netfilter_conntrack is missing on target. Skipping ${PROJECT_NAME} build.")
ENDIF(CURSES_FOUND AND CMAKE_HAVE_PTHREAD_CREATE AND LIBGEOIP_FOUND AND LIBNETFILTER_CONNTRACK_FOUND AND LIBURCU_FOUND)

=== src/ifpps/CMakeLists.txt ===
PROJECT(ifpps C)

SET(BUILD_STRING "generic")

FIND_PACKAGE(Curses)
INCLUDE(Pod2Man)

IF(CURSES_FOUND)
	ADD_EXECUTABLE(${PROJECT_NAME}	../xmalloc.c
					../xio.c
					../xutils.c
					../ifpps.c)
	ADD_DEFINITIONS(-DPROGNAME_STRING="${PROJECT_NAME}"
			-DVERSION_STRING="${VERSION}"
			-DBUILD_STRING="${BUILD_STRING}")
	TARGET_LINK_LIBRARIES(ifpps ${CURSES_NCURSES_LIBRARY})
	POD2MAN(${CMAKE_SOURCE_DIR}/ifpps.c ifpps 8)
	INSTALL(TARGETS ${PROJECT_NAME} DESTINATION ${EXECUTABLE_INSTALL_PATH})
ELSE(CURSES_FOUND)
	MESSAGE("ncurses is missing on target. Skipping ${PROJECT_NAME} build.")
ENDIF(CURSES_FOUND)

=== src/netsniff-ng/CMakeLists.txt ===
PROJECT(netsniff-ng C)

SET(BUILD_STRING "generic")
FIND_PACKAGE(Threads)
FIND_PACKAGE(Libnl)
INCLUDE(Pod2Man)

IF (CMAKE_HAVE_PTHREAD_CREATE AND LIBNL_FOUND)
	ADD_EXECUTABLE(${PROJECT_NAME} 	../hash.c
					../dissector.c
					../dissector_eth.c
					../dissector_80211.c
					../proto_arp.c
					../proto_ethernet.c
					../proto_icmpv4.c
					../proto_icmpv6.c
					../proto_igmp.c
					../proto_ip_authentication_hdr.c
					../proto_ip_esp.c
					../proto_ipv4.c
					../proto_ipv6.c
					../proto_ipv6_dest_opts.c
					../proto_ipv6_fragm.c
					../proto_ipv6_hop_by_hop.c
					../proto_ipv6_in_ipv4.c
					../proto_ipv6_mobility_hdr.c
					../proto_ipv6_no_nxt_hdr.c
					../proto_ipv6_routing.c
					../proto_none.c
					../proto_tcp.c
					../proto_udp.c
					../proto_vlan.c
					../proto_vlan_q_in_q.c
					../proto_mpls_unicast.c
					../proto_80211_mac_hdr.c
					../xmalloc.c
					../oui.c
					../xio.c
					../xutils.c
					../bpf.c
					../mac80211.c
					../pcap.c
					../pcap_rw.c
					../pcap_sg.c
					../pcap_mmap.c
					../ring_rx.c
					../ring_tx.c
					../mtrand.c
					../tprintf.c
					../netsniff-ng.c)
	ADD_DEFINITIONS(-DPROGNAME_STRING="${PROJECT_NAME}"
		-DVERSION_STRING="${VERSION}"
		-DBUILD_STRING="${BUILD_STRING}"
		-D_FILE_OFFSET_BITS=64
		-D_LARGEFILE_SOURCE
		-D_LARGEFILE64_SOURCE
		-D__WITH_PROTOS)
#		-D__WITH_HARDWARE_TIMESTAMPING)
	POD2MAN(${CMAKE_SOURCE_DIR}/netsniff-ng.c netsniff-ng 8)
	TARGET_LINK_LIBRARIES(netsniff-ng ${CMAKE_THREAD_LIBS_INIT} ${LIBNL_LIBRARIES})
	INSTALL(FILES ${rules_files} DESTINATION ${CONFIG_INSTALL_PATH}/rules/)
	INSTALL(FILES ../conf/ether.conf ../conf/tcp.conf ../conf/udp.conf ../conf/oui.conf DESTINATION ${CONFIG_INSTALL_PATH})
	INSTALL(TARGETS ${PROJECT_NAME} DESTINATION ${EXECUTABLE_INSTALL_PATH})
ELSE(CMAKE_HAVE_PTHREAD_CREATE AND LIBNL_FOUND)
	MESSAGE("pthread or libnl is missing on target. Skipping ${PROJECT_NAME} build.")
ENDIF(CMAKE_HAVE_PTHREAD_CREATE AND LIBNL_FOUND)

=== src/trafgen/CMakeLists.txt ===
PROJECT(trafgen C)

FIND_PACKAGE(FLEX)
FIND_PACKAGE(BISON)
FIND_PACKAGE(LibCLI)
FIND_PACKAGE(Libnl)
INCLUDE(Pod2Man)

SET(BUILD_STRING "generic")

IF(LIBCLI_FOUND AND FLEX_FOUND AND BISON_FOUND AND LIBNL_FOUND)
        FLEX_TARGET(BPF_LEXER ../trafgen_lexer.l ${CMAKE_CURRENT_BINARY_DIR}/trafgen_lex.yy.c)
        BISON_TARGET(BPF_PARSER ../trafgen_parser.y ${CMAKE_CURRENT_BINARY_DIR}/trafgen_parser.tab.c)
	ADD_EXECUTABLE(${PROJECT_NAME} 	../xmalloc.c
					../xio.c
					../xutils.c
					../mtrand.c
					../mac80211.c
					../ring_tx.c
					${FLEX_BPF_LEXER_OUTPUTS}
					${BISON_BPF_PARSER_OUTPUT_SOURCE}
					../trafgen_cli.c
					../trafgen.c)
	ADD_DEFINITIONS(-DPROGNAME_STRING="${PROJECT_NAME}"
			-DVERSION_STRING="${VERSION}"
			-DBUILD_STRING="${BUILD_STRING}")
	TARGET_LINK_LIBRARIES(trafgen ${LIBCLI_LIBRARY} ${LIBNL_LIBRARIES})
	POD2MAN(${CMAKE_SOURCE_DIR}/trafgen.c trafgen 8)
	INSTALL(TARGETS ${PROJECT_NAME} DESTINATION ${EXECUTABLE_INSTALL_PATH})
ELSE(LIBCLI_FOUND AND FLEX_FOUND AND BISON_FOUND AND LIBNL_FOUND)
	MESSAGE("libcli-dev or libnl is missing on target. Skipping ${PROJECT_NAME} build.")
ENDIF(LIBCLI_FOUND AND FLEX_FOUND AND BISON_FOUND AND LIBNL_FOUND)

=== debian/changelog ===
netsniff-ng (0.5.7-1) unstable; urgency=low

  * New upstream release
  * debian/copyright:
    + License is GPL-2, not GPL-2+
  * debian/control:
    + Added Build-Depends: libcli-dev, libnl-dev for trafgen, netsniff-ng
      binaries.
    + Updated maintainer email address.
  * debian/patches/cflags_notune.patch:
    + Added patch to fix CFLAGS from upstream.
  * debian/docs:
    + Removed THANKS, not provided by upstream now.
  * debian/rules:
    + Provides upstream changelogs.

 -- Kartik Mistry <kartik@debian.org>  Sat, 30 Jun 2012 11:52:47 +0530

netsniff-ng (0.5.6-2) unstable; urgency=low

  * debian/control:
    + Set archs to: i386, amd64, powerpc and sparc only as dependencies are not
      available or missing on other than these archs.
    + Added Recommends: ntp. Thanks to Carlos Alberto Lopez Perez
      <clopez@igalia.com>.
    + Build-Depends on libncurses5-dev for missing flowtop and ifpps binaries.
  * debian/copyright:
    + Removed duplicate copyright fields.
    + Added Debian packaging copyright section.
  * Added hardening support.

 -- Kartik Mistry <kartik@debian.org>  Thu, 21 Jun 2012 16:36:41 +0530

netsniff-ng (0.5.6-1) unstable; urgency=low

  * New upstream release (Closes: #667609)
  * debian/patches:
    + 01_manpage_fix.diff: Removed, merge upstream.
    + nacl_path_fix: Added patch to fix Nacl header and library paths.
    + manpage_path.patch: Added patch to fix manpage installation path from
      upstream.
  * debian/rules:
    + Upstream moved to CMake. Changes related to it.
    + Added missing build targets.
  * debian/control:
    + Added Build-Deps needed for CMake build system and libs.
    + Updated Standards-Version to 3.9.3
    + Updated long description.
  * debian/copyright:
    + Updated to copyright-format 1.0
    + Updated copyright for some files.
  * debian/docs:
    + Updated as per upstream changes.

 -- Kartik Mistry <kartik@debian.org>  Sun, 01 Apr 2012 11:05:41 +0530

=== debian/control ===
Source: netsniff-ng
Section: net
Priority: optional
Build-Depends: bison,
               cmake,
               debhelper (>= 7),
               dpkg-dev (>= 1.16.1~),
               flex,
               libcli-dev,
               libgeoip-dev,
               libnacl-dev,
               libncurses5-dev,
               libnetfilter-conntrack-dev,
               libnl-dev,
               liburcu-dev
Maintainer: Daniel Borkmann <daniel@netsniff-ng.org>
Uploaders: Kartik Mistry <kartik@debian.org>
Standards-Version: 3.9.3
Homepage: http://www.netsniff-ng.org/

Package: netsniff-ng
Architecture: amd64 i386 powerpc sparc
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: ntp
Description: packet sniffing beast
 netsniff-ng is a high performance Linux network sniffer for packet inspection.
 It can be used for protocol analysis, reverse engineering or network
 debugging. The gain of performance is reached by 'zero-copy' mechanisms, so
 that the kernel does not need to copy packets from kernelspace to userspace.
 .
 netsniff-ng toolkit currently consists of the following utilities:
 .
  * netsniff-ng: the zero-copy sniffer, pcap capturer and replayer itself.
  * trafgen: a high performance zero-copy network packet generator.
  * ifpps: a top-like kernel networking and system statistics tool.
  * curvetun: a lightweight curve25519-based multiuser IP tunnel.
  * ashunt: an autonomous system trace route and ISP testing utility.
  * flowtop: a top-like netfilter connection tracking tool.
  * bpfc: a tiny Berkeley Packet Filter compiler supporting Linux extensions.

=== debian/rules ===
#!/usr/bin/make -f
#
# debian/rules for netsniff-ng
# by Daniel Borkmann

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

build: build-arch build-indep
build-arch: build-stamp
build-indep: build-stamp
build-stamp:
	dh_testdir
	mkdir -p src/build; cd src/build; \
	cmake -DCMAKE_INSTALL_PREFIX=/usr ..; \
	$(MAKE) DESTDIR=$(CURDIR)/debian/netsniff-ng all
	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp
	rm -rf src/build
	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs
	cd src/build; $(MAKE) install DESTDIR=$(CURDIR)/debian/netsniff-ng

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installdocs
	dh_installexamples
	dh_installman
	dh_installchangelogs -k Documentation/RelNotes/Notes-0.5.7
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-arch binary-indep
.PHONY: build build-arch build-indep clean binary-indep binary-arch binary install

=== debian/watch ===
version=3
opts=dversionmangle=s/~// \
 http://www.netsniff-ng.org/pub/netsniff-ng/netsniff-ng-(.*)\.tar\.gz

## netsniff-ng 0.5.8

=== Makefile ===
# netsniff-ng build system
# Copyright 2012 - 2013 Daniel Borkmann <borkmann@gnumaniacs.org>
# Copyright 2013 Tobias Klauser <tklauser@distanz.ch>
# Subject to the GNU GPL, version 2.

-include Config
-include Cmds
-include Extra
-include Template
-include Misc

ifndef CONFIG_OK
  $(error "Please run `./configure' before `make'")
endif

VERSION = 0
PATCHLEVEL = 5
SUBLEVEL = 8
EXTRAVERSION =
NAME = Ziggomatic

TOOLS ?= $(CONFIG_TOOLS)
TOOLS ?= netsniff-ng trafgen astraceroute flowtop ifpps bpfc curvetun mausezahn

# For packaging purposes, prefix can define a different path.
PREFIX ?= /usr/local

# Disable if you don't want it
CCACHE ?= $(CONFIG_CCACHE)

# Location of an alternative destination directory for installation
# Useful when cross-compiling and installing in a dedicated target directory
DESTDIR=

# Location of installation paths.
SBINDIR = $(PREFIX)/sbin
INCDIR = $(PREFIX)/include
ETCDIR = $(PREFIX)/etc
ETCDIRE = $(ETCDIR)/netsniff-ng
MAN8DIR = $(PREFIX)/share/man/man8

# Shut up make, helper warnings, parallel compilation!
MAKEFLAGS += --no-print-directory
MAKEFLAGS += -rR
MAKEFLAGS += --warn-undefined-variables
MAKEFLAGS += --jobs=$(shell grep "^processor" /proc/cpuinfo | wc -l)

# Debugging option
ifeq ("$(origin DEBUG)", "command line")
  DEBUG := 1
else
  DEBUG := 0
endif

# For packaging purposes, you might want to call your own:
#   make CFLAGS="<flags>"
CFLAGS_DEF  = -std=gnu99
CFLAGS_DEF += -pipe

ifeq ($(DEBUG), 1)
  CFLAGS_DEF += -O2
  CFLAGS_DEF += -g
else
 ifeq ($(DISTRO), 1)
  CFLAGS_DEF += -O2
 else
  CFLAGS_DEF += -march=native
  CFLAGS_DEF += -mtune=native
  CFLAGS_DEF += -O3
 endif
endif
ifeq ($(HARDENING), 1)
  CFLAGS_DEF += -fPIE -pie
  CFLAGS_DEF += -Wl,-z,relro,-z,now
  CFLAGS_DEF += -fstack-protector-all
  CFLAGS_DEF += -Wstack-protector
  CFLAGS_DEF += --param=ssp-buffer-size=4
  CFLAGS_DEF += -ftrapv
  CFLAGS_DEF += -U_FORTIFY_SOURCE -D_FORTIFY_SOURCE=2
  CFLAGS_DEF += -fexceptions
endif

CFLAGS_DEF += -fomit-frame-pointer
CFLAGS_DEF += -fno-strict-aliasing
CFLAGS_DEF += -fasynchronous-unwind-tables
CFLAGS_DEF += -fno-delete-null-pointer-checks

CFLAGS_MIN  = -D_REENTRANT
CFLAGS_MIN += -D_LARGEFILE_SOURCE
CFLAGS_MIN += -D_LARGEFILE64_SOURCE
CFLAGS_MIN += -D_FILE_OFFSET_BITS=64
CFLAGS_MIN += -DVERSION_STRING=\"$(VERSION_STRING)\"
CFLAGS_MIN += -DVERSION_LONG=\"$(VERSION_LONG)\"
CFLAGS_MIN += -DETCDIRE_STRING=\"$(ETCDIRE)\"

WFLAGS_DEF  = -Wall

CPPFLAGS  ?=
CFLAGS    ?= $(CFLAGS_DEF) $(WFLAGS_DEF) $(CPPFLAGS)
override CFLAGS += $(CFLAGS_MIN) -I.

LEX_FLAGS  =
YAAC_FLAGS =

LDFLAGS   ?=
ifeq ("$(origin CROSS_LD_LIBRARY_PATH)", "command line")
  LDFLAGS += -L$(CROSS_LD_LIBRARY_PATH)
endif

VERSION_SHORT  =  $(VERSION).$(PATCHLEVEL).$(SUBLEVEL)$(EXTRAVERSION)
VERSION_STRING = "$(VERSION_SHORT)$(CONFIG_RC)"
VERSION_LONG   = "$(VERSION_SHORT)$(CONFIG_RC) ($(NAME))"

export VERSION PATCHLEVEL SUBLEVEL EXTRAVERSION
export CROSS_COMPILE
export DEBUG DISTRO HARDENING

bold   = $(shell tput bold)
normal = $(shell tput sgr0)

ifeq ("$(origin CROSS_COMPILE)", "command line")
  WHAT := Cross compiling
else
  WHAT := Building
endif

build_showinfo:
	$(Q)echo "$(bold)$(WHAT) netsniff-ng toolkit ($(VERSION_STRING)) for" \
	      $(shell $(CCNQ) -dumpmachine)":$(normal)"
clean_showinfo:
	$(Q)echo "$(bold)Cleaning netsniff-ng toolkit ($(VERSION_STRING)):$(normal)"

.PHONY: all toolkit $(TOOLS) clean %_prehook %_clean %_install %_uninstall tag tags cscope
.IGNORE: %_clean_custom %_install_custom
.NOTPARALLEL: $(TOOLS)
.DEFAULT_GOAL := all
.DEFAULT:
.FORCE:

all: build_showinfo toolkit
allbutcurvetun: $(filter-out curvetun,$(TOOLS))
allbutmausezahn: $(filter-out mausezahn,$(TOOLS))
toolkit: $(TOOLS)
clean: $(foreach tool,$(TOOLS),$(tool)_clean)
distclean: clean
	$(Q)$(call RM,Config)
	$(Q)$(call RM,config.h)
	$(Q)$(call RM,config.log)
	$(Q)$(call RM,cov-int)
	$(Q)$(call RM,netsniff-ng-coverity.tgz)
mrproper: distclean
	$(Q)$(GIT_REM)

install: install_all
install_all: $(foreach tool,$(TOOLS),$(tool)_install)
install_allbutcurvetun: $(foreach tool,$(filter-out curvetun,$(TOOLS)),$(tool)_install)
install_allbutmausezahn: $(foreach tool,$(filter-out mausezahn,$(TOOLS)),$(tool)_install)
uninstall: $(foreach tool,$(TOOLS),$(tool)_uninstall)

%.yy.o: %.l
	$(LEX) -P $(shell perl -wlne 'print $$1 if /lex-func-prefix:\s([a-z]+)/' $<) \
	       -o $(BUILD_DIR)/$(shell basename $< .l).yy.c $(LEX_FLAGS) $<
%.tab.o: %.y
	$(YAAC) -p $(shell perl -wlne 'print $$1 if /yaac-func-prefix:\s([a-z]+)/' $<) \
		-o $(BUILD_DIR)/$(shell basename $< .y).tab.c $(YAAC_FLAGS) -d $<

$(foreach tool,$(TOOLS),$(eval $(call TOOL_templ,$(tool))))

%:: ;

$(TOOLS):
	$(LD) $(LDFLAGS) -o $@/$@ $@/*.o $($@-libs)
	$(STRIP) $@/$@

=== curvetun/Makefile ===
curvetun-libs =	-l${CONFIG_NACL_LIB} \
		-lpthread

curvetun-objs =	xmalloc.o \
		epoll2.o \
		str.o \
		dev.o \
		stun.o \
		sock.o \
		sig.o \
		link.o \
		patricia.o \
		corking.o \
		trie.o \
		taia.o \
		hash.o \
		rnd.o \
		curve.o \
		curve_test.o \
		cookie.o \
		keypair.o \
		ioexact.o \
		ioops.o \
		cpusched.o \
		curvetun_mgmt_servers.o \
		curvetun_mgmt_users.o \
		curvetun_server.o \
		curvetun_client.o \
		curvetun.o

curvetun-eflags = -I ${CONFIG_NACL_INC_DIR}

curvetun-confs =

=== flowtop/Makefile ===
flowtop-libs =	-lGeoIP \
		-lurcu \
		-lnetfilter_conntrack \
		$(shell pkg-config --libs ncurses 2> /dev/null \
			|| echo '-lncurses') \
		$(shell pkg-config --libs tinfo 2> /dev/null ) \
		-lpthread \
		-lz

flowtop-objs =	xmalloc.o \
		ioops.o \
		oui.o \
		str.o \
		sig.o \
		sock.o \
		dev.o \
		link.o \
		hash.o \
		dissector_eth.o \
		dissector_80211.o \
		dissector.o \
		proto_none.o \
		tprintf.o \
		geoip.o \
		screen.o \
		flowtop.o

flowtop-eflags = $(shell pkg-config --cflags ncurses)

flowtop-confs =	tcp.conf \
		udp.conf \
		geoip.conf

=== ifpps/Makefile ===
ifpps-libs =	$(shell pkg-config --libs ncurses 2> /dev/null \
			|| echo '-lncurses') \
		$(shell pkg-config --libs tinfo 2> /dev/null )

ifpps-objs =	xmalloc.o \
		ioops.o \
		str.o \
		link.o \
		sock.o \
		dev.o \
		sig.o \
		screen.o \
		ifpps.o

ifpps-eflags = $(shell pkg-config --cflags ncurses 2> /dev/null)

ifpps-confs =

=== mausezahn/Makefile ===
mausezahn-libs =	-lcli \
			-lnet \
			-lpcap \
			-lrt \
			-lpthread \
			-lm

mausezahn-objs =	str.o \
			staging/layer1.o \
			staging/layer2.o \
			staging/layer3.o \
			staging/layer4.o \
			staging/hextools.o \
			staging/tools.o \
			staging/lookupdev.o \
			staging/time.o \
			staging/modifications.o \
			staging/send_eth.o \
			staging/send.o \
			staging/cdp.o \
			staging/rtp.o \
			staging/dns.o \
			staging/rcv_rtp.o \
			staging/syslog.o \
			staging/cli.o \
			staging/cli_cmds.o \
			staging/cli_launch.o \
			staging/cli_legacy.o \
			staging/cli_packet.o \
			staging/cli_interface.o \
			staging/cli_set.o \
			staging/cli_dns.o \
			staging/cli_arp.o \
			staging/cli_bpdu.o \
			staging/cli_eth.o \
			staging/cli_ip.o \
			staging/cli_udp.o \
			staging/cli_tcp.o \
			staging/cli_rtp.o \
			staging/cli_tools.o \
			staging/cli_igmp.o \
			staging/cli_lldp.o \
			staging/cli_sequence.o \
			staging/mops.o \
			staging/mops_update.o \
			staging/mops_tools.o \
			staging/mops_checksums.o \
			staging/mops_threads.o \
			staging/mops_dot1Q.o \
			staging/mops_mpls.o \
			staging/mops_ip.o \
			staging/mops_tcp.o \
			staging/mops_ext.o \
			staging/mops_ext_arp.o \
			staging/mops_ext_bpdu.o \
			staging/mops_ext_rtp.o \
			staging/mopsrx_arp.o \
			staging/mops_ext_igmp.o \
			staging/mops_ext_lldp.o \
			staging/mops_sequence.o \
			staging/automops.o \
			staging/parse_xml.o \
			staging/tx_switch.o \
			staging/llist.o \
			staging/directmops.o \
			staging/mausezahn.o

mausezahn-eflags = -O2 -I. -I.. \
		   -DVERSION_STRING=\"$(VERSION_STRING)\" \
		   -DVERSION_LONG=\"$(VERSION_LONG)\"

mausezahn-confs =

=== netsniff-ng/Makefile ===
netsniff-ng-libs =	$(shell pkg-config --libs libnl-3.0) \
			$(shell pkg-config --libs libnl-genl-3.0) \
			-lpthread

ifeq ($(CONFIG_LIBPCAP), 1)
netsniff-ng-libs +=	-lpcap
endif
ifeq ($(CONFIG_GEOIP), 1)
netsniff-ng-libs +=	-lGeoIP \
			-lz
endif

netsniff-ng-objs =	dissector.o \
			dissector_eth.o \
			dissector_80211.o \
			proto_arp.o \
			proto_ethernet.o \
			proto_icmpv4.o \
			proto_icmpv6.o \
			proto_igmp.o \
			proto_ip_authentication_hdr.o \
			proto_ip_esp.o \
			proto_ipv4.o \
			proto_ipv6.o \
			proto_ipv6_dest_opts.o \
			proto_ipv6_fragm.o \
			proto_ipv6_hop_by_hop.o \
			proto_ipv6_in_ipv4.o \
			proto_ipv6_mobility_hdr.o \
			proto_ipv6_no_nxt_hdr.o \
			proto_ipv6_routing.o \
			proto_lldp.o \
			proto_none.o \
			proto_tcp.o \
			proto_udp.o \
			proto_vlan.o \
			proto_vlan_q_in_q.o \
			proto_mpls_unicast.o \
			proto_80211_mac_hdr.o \
			privs.o \
			proc.o \
			dev.o \
			str.o \
			sig.o \
			sock.o \
			irq.o \
			iosched.o \
			ioops.o \
			link.o \
			xmalloc.o \
			hash.o \
			bpf.o \
			oui.o \
			pcap_rw.o \
			pcap_sg.o \
			pcap_mm.o \
			ring_rx.o \
			ring_tx.o \
			ring.o \
			tprintf.o \
			timer.o \
			mac80211.o \
			netsniff-ng.o

ifeq ($(CONFIG_LIBPCAP), 1)
netsniff-ng-objs +=	bpf_comp.o
endif
ifeq ($(CONFIG_GEOIP), 1)
netsniff-ng-objs +=	geoip.o
endif
ifeq ($(CONFIG_HWTSTAMP), 1)
netsniff-ng-objs +=	tstamping.o
endif

netsniff-ng-eflags = $(shell pkg-config --cflags libnl-3.0) \
		     $(shell pkg-config --cflags libnl-genl-3.0) \
		     -DHAVE_DISSECTOR_PROTOS -DNEED_TCPDUMP_LIKE_FILTER

netsniff-ng-confs =	ether.conf \
			tcp.conf \
			udp.conf \
			oui.conf \
			geoip.conf

=== trafgen/Makefile ===
trafgen-libs =	$(shell pkg-config --libs libnl-3.0) \
		$(shell pkg-config --libs libnl-genl-3.0) \
		-lm

trafgen-objs =	xmalloc.o \
		ioops.o \
		privs.o \
		proc.o \
		dev.o \
		irq.o \
		link.o \
		str.o \
		sig.o \
		sock.o \
		mac80211.o \
		ring_tx.o \
		ring.o \
		timer.o \
		trafgen_lexer.yy.o \
		trafgen_parser.tab.o \
		trafgen.o

trafgen-lex =	trafgen_lexer.yy.o

trafgen-yaac =	trafgen_parser.tab.o

trafgen-eflags = $(shell pkg-config --cflags libnl-3.0) \
		 $(shell pkg-config --cflags libnl-genl-3.0) \
		 -DHAVE_DISSECTOR_PROTOS -I..

trafgen-confs =	trafgen_stddef.h

trafgen_post_install:
	$(Q)mv $(DESTDIR)$(ETCDIRE)/trafgen_stddef.h $(DESTDIR)$(ETCDIRE)/stddef.h

trafgen_clean_custom:
	$(Q)$(call RM,$(BUILD_DIR)/*.h $(BUILD_DIR)/*.c)

=== debian/changelog ===
netsniff-ng (0.5.8-2build1) utopic; urgency=medium

  * No-change rebuild against liburcu2.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 10 Jul 2014 05:51:11 +0000

netsniff-ng (0.5.8-2) unstable; urgency=low

  * debian/control:
    + Replaced ashunt with astraceroute in long description.
  * Updated debian/watch file.

 -- Kartik Mistry <kartik@debian.org>  Thu, 01 May 2014 14:54:51 +0530

netsniff-ng (0.5.8-1) unstable; urgency=low

  * New upstream release:
    + Dropped all patches. Merged upstream.
  * Uploaded to unstable.
  * debian/control:
    + Updated short description (Closes: #741997)
    + Added mausezahn in long description.
    + Added Tobias Klauser as Uploaders.
  * debian/rules:
    + Fixed installation as per upstream changes.
    + Removed unused dh_installexamples

 -- Kartik Mistry <kartik@debian.org>  Wed, 30 Apr 2014 21:12:59 +0530

netsniff-ng (0.5.8~rc5-2) experimental; urgency=low

  * debian/control:
    + Updated Daniel Borkmann's email address (Closes: #741327)
  * debian/rules:
    + Do not add PREFIX in make.
    + Do not remove config.h file in clean target.

 -- Kartik Mistry <kartik@debian.org>  Tue, 11 Mar 2014 16:12:59 +0530

netsniff-ng (0.5.8~rc5-1) experimental; urgency=low

  * New upstream RC release:
    + Removed patches merged in upstream.
    + Updated manpage_fix patch.
  * debian/control:
    + Added VCS-* fields.
    + Enabled ia64 and mips archs as liburcu-dev supports them now.
    + Updated build-depends to libnl-3-dev (Closes: #688171)
    + Updated Standards-Version to 3.9.5
  * debian/rules:
    + Fixed clean target.
    + Fixed hardening support.
  * debian/docs:
    + Documentation/ folder no longer exists.
  * Updated debian/watch file.

 -- Kartik Mistry <kartik@debian.org>  Mon, 10 Mar 2014 18:28:13 +0530

=== debian/control ===
Source: netsniff-ng
Section: net
Priority: optional
Build-Depends: bison,
               cmake,
               debhelper (>= 7),
               dpkg-dev (>= 1.16.1~),
               flex,
               libcli-dev,
               libgeoip-dev,
               libnacl-dev,
               libncurses5-dev,
               libnet1-dev,
               libnetfilter-conntrack-dev,
               libnl-3-dev,
               libnl-genl-3-dev,
               libpcap-dev,
               liburcu-dev,
               zlib1g-dev
Maintainer: Daniel Borkmann <daniel.borkmann@alumni.ethz.ch>
Uploaders: Kartik Mistry <kartik@debian.org>,
           Tobias Klauser <tklauser@distanz.ch>
Standards-Version: 3.9.5
Homepage: http://www.netsniff-ng.org/
Vcs-Git: git://anonscm.debian.org/collab-maint/netsniff-ng.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/netsniff-ng;a=summary

Package: netsniff-ng
Architecture: amd64 i386 ia64 mips powerpc sparc
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: ntp
Description: Linux network packet sniffer toolkit
 netsniff-ng is a high performance Linux network sniffer for packet inspection.
 It can be used for protocol analysis, reverse engineering or network
 debugging. The gain of performance is reached by 'zero-copy' mechanisms, so
 that the kernel does not need to copy packets from kernelspace to userspace.
 .
 netsniff-ng toolkit currently consists of the following utilities:
 .
  * netsniff-ng: the zero-copy sniffer, pcap capturer and replayer itself.
  * astraceroute: an autonomous system trace route and DPI testing utility.
  * bpfc: a tiny Berkeley Packet Filter compiler supporting Linux extensions.
  * curvetun: a lightweight curve25519-based multiuser IP tunnel.
  * flowtop: a top-like netfilter connection tracking tool.
  * ifpps: a top-like kernel networking and system statistics tool.
  * mausezahn: a fast versatile packet generator with Cisco-cli.
  * trafgen: a high performance zero-copy network packet generator.

## netsniff-ng 0.5.9

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 # netsniff-ng build system
 # Copyright 2012 - 2013 Daniel Borkmann <borkmann@gnumaniacs.org>
-# Copyright 2013 Tobias Klauser <tklauser@distanz.ch>
+# Copyright 2013 - 2015 Tobias Klauser <tklauser@distanz.ch>
 # Subject to the GNU GPL, version 2.
 
 -include Config
@@ -15,9 +15,9 @@
 
 VERSION = 0
 PATCHLEVEL = 5
-SUBLEVEL = 8
+SUBLEVEL = 9
 EXTRAVERSION =
-NAME = Ziggomatic
+NAME = Cilonen
 
 TOOLS ?= $(CONFIG_TOOLS)
 TOOLS ?= netsniff-ng trafgen astraceroute flowtop ifpps bpfc curvetun mausezahn
@@ -25,8 +25,8 @@
 # For packaging purposes, prefix can define a different path.
 PREFIX ?= /usr/local
 
-# Disable if you don't want it
-CCACHE ?= $(CONFIG_CCACHE)
+# Set to use ccache for compilation
+CCACHE ?=
 
 # Location of an alternative destination directory for installation
 # Useful when cross-compiling and installing in a dedicated target directory
@@ -35,7 +35,7 @@
 # Location of installation paths.
 SBINDIR = $(PREFIX)/sbin
 INCDIR = $(PREFIX)/include
-ETCDIR = $(PREFIX)/etc
+ETCDIR ?= /etc
 ETCDIRE = $(ETCDIR)/netsniff-ng
 MAN8DIR = $(PREFIX)/share/man/man8
 
@@ -52,23 +52,26 @@
   DEBUG := 0
 endif
 
+# Compiler detection
+ifneq ($(CC),)
+ifeq ($(shell $(CC) -v 2>&1 | grep -c "clang version"), 1)
+COMPILER := clang
+else
+COMPILER := gcc
+endif
+export COMPILER
+endif
+
 # For packaging purposes, you might want to call your own:
 #   make CFLAGS="<flags>"
 CFLAGS_DEF  = -std=gnu99
 CFLAGS_DEF += -pipe
+CFLAGS_DEF += -O2
 
 ifeq ($(DEBUG), 1)
-  CFLAGS_DEF += -O2
   CFLAGS_DEF += -g
-else
- ifeq ($(DISTRO), 1)
-  CFLAGS_DEF += -O2
- else
-  CFLAGS_DEF += -march=native
-  CFLAGS_DEF += -mtune=native
-  CFLAGS_DEF += -O3
- endif
 endif
+
 ifeq ($(HARDENING), 1)
   CFLAGS_DEF += -fPIE -pie
   CFLAGS_DEF += -Wl,-z,relro,-z,now
@@ -83,7 +86,9 @@
 CFLAGS_DEF += -fomit-frame-pointer
 CFLAGS_DEF += -fno-strict-aliasing
 CFLAGS_DEF += -fasynchronous-unwind-tables
+ifneq ($(COMPILER), clang)
 CFLAGS_DEF += -fno-delete-null-pointer-checks
+endif
 
 CFLAGS_MIN  = -D_REENTRANT
 CFLAGS_MIN += -D_LARGEFILE_SOURCE
@@ -107,19 +112,21 @@
   LDFLAGS += -L$(CROSS_LD_LIBRARY_PATH)
 endif
 
+CHECKFLAGS = -D__linux__ -Dlinux -D__STDC__ -Dunix -D__unix \
+	     -Wbitwise -Wnoreturn-void
+
 VERSION_SHORT  =  $(VERSION).$(PATCHLEVEL).$(SUBLEVEL)$(EXTRAVERSION)
 VERSION_STRING = "$(VERSION_SHORT)$(CONFIG_RC)"
 VERSION_LONG   = "$(VERSION_SHORT)$(CONFIG_RC) ($(NAME))"
 
 export VERSION PATCHLEVEL SUBLEVEL EXTRAVERSION
-export CROSS_COMPILE
-export DEBUG DISTRO HARDENING
+export DEBUG HARDENING
 
 bold   = $(shell tput bold)
 normal = $(shell tput sgr0)
 
-ifeq ("$(origin CROSS_COMPILE)", "command line")
-  WHAT := Cross compiling
+ifneq ("$(CROSS_COMPILE)", "")
+  WHAT := Cross-compiling
 else
   WHAT := Building
 endif
@@ -169,5 +176,5 @@
 %:: ;
 
 $(TOOLS):
-	$(LD) $(LDFLAGS) -o $@/$@ $@/*.o $($@-libs)
-	$(STRIP) $@/$@
+	$(LDQ) $(LDFLAGS) -o $@/$@ $@/*.o $($@-libs)
+	$(STRIPQ) $@/$@

=== astraceroute/Makefile ===
astraceroute-libs =	-lpthread

ifeq ($(CONFIG_GEOIP), 1)
astraceroute-libs +=	-lGeoIP \
			-lz
endif


astraceroute-objs =	xmalloc.o \
			proto_none.o \
			tprintf.o \
			bpf.o \
			str.o \
			sig.o \
			sock.o \
			link.o \
			dev.o \
			ring.o \
			die.o \
			astraceroute.o

ifeq ($(CONFIG_GEOIP), 1)
astraceroute-objs +=	geoip.o \
			ioops.o
endif

astraceroute-eflags =

astraceroute-confs =	geoip.conf

=== bpfc/Makefile ===
bpfc-libs =

bpfc-objs =	xmalloc.o \
		str.o \
		bpf.o \
		bpf_lexer.yy.o \
		bpf_parser.tab.o \
		die.o \
		bpfc.o

bpfc-lex =	bpf_lexer.yy.o

bpfc-yaac =	bpf_parser.tab.o

bpfc-eflags =	-I..

bpfc-confs =

bpfc_clean_custom:
	$(Q)$(call RM,$(BUILD_DIR)/*.h $(BUILD_DIR)/*.c)

=== curvetun/Makefile ===
--- 
+++ 
@@ -22,6 +22,7 @@
 		ioexact.o \
 		ioops.o \
 		cpusched.o \
+		die.o \
 		curvetun_mgmt_servers.o \
 		curvetun_mgmt_users.o \
 		curvetun_server.o \

=== flowtop/Makefile ===
flowtop-libs =	-lurcu \
		-lnetfilter_conntrack \
		$(shell PKG_CONFIG_PATH=$(PKG_CONFIG_PATH) $(PKG_CONFIG) --libs ncurses 2> /dev/null \
			|| echo '-lncurses') \
		$(shell PKG_CONFIG_PATH=$(PKG_CONFIG_PATH) $(PKG_CONFIG) --libs tinfo 2> /dev/null ) \
		-lpthread

ifeq ($(CONFIG_GEOIP), 1)
flowtop-libs +=	-lGeoIP \
		-lz
endif

flowtop-objs =	xmalloc.o \
		oui.o \
		str.o \
		sig.o \
		sock.o \
		dev.o \
		link.o \
		hash.o \
		lookup.o \
		tprintf.o \
		screen.o \
		die.o \
		flowtop.o

ifeq ($(CONFIG_GEOIP), 1)
flowtop-objs +=	geoip.o \
		ioops.o
endif

flowtop-eflags = $(shell $(PKG_CONFIG) --cflags ncurses)

flowtop-confs =	tcp.conf \
		udp.conf \
		geoip.conf

=== ifpps/Makefile ===
ifpps-libs =	$(shell PKG_CONFIG_PATH=$(PKG_CONFIG_PATH) $(PKG_CONFIG) --libs ncurses 2> /dev/null \
			|| echo '-lncurses') \
		$(shell PKG_CONFIG_PATH=$(PKG_CONFIG_PATH) $(PKG_CONFIG) --libs tinfo 2> /dev/null )

ifpps-objs =	xmalloc.o \
		ioops.o \
		str.o \
		link.o \
		sock.o \
		dev.o \
		sig.o \
		screen.o \
		die.o \
		ifpps.o

ifpps-eflags = $(shell PKG_CONFIG_PATH=$(PKG_CONFIG_PATH) $(PKG_CONFIG) --cflags ncurses 2> /dev/null)

ifpps-confs =

=== netsniff-ng/Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
-netsniff-ng-libs =	$(shell pkg-config --libs libnl-3.0) \
-			$(shell pkg-config --libs libnl-genl-3.0) \
+netsniff-ng-libs =	$(shell PKG_CONFIG_PATH=$(PKG_CONFIG_PATH) $(PKG_CONFIG) --libs libnl-3.0) \
+			$(shell PKG_CONFIG_PATH=$(PKG_CONFIG_PATH) $(PKG_CONFIG) --libs libnl-genl-3.0) \
 			-lpthread
 
 ifeq ($(CONFIG_LIBPCAP), 1)
@@ -13,6 +13,8 @@
 netsniff-ng-objs =	dissector.o \
 			dissector_eth.o \
 			dissector_80211.o \
+			dissector_netlink.o \
+			lookup.o \
 			proto_arp.o \
 			proto_ethernet.o \
 			proto_icmpv4.o \
@@ -30,6 +32,7 @@
 			proto_ipv6_no_nxt_hdr.o \
 			proto_ipv6_routing.o \
 			proto_lldp.o \
+			proto_nlmsg.o \
 			proto_none.o \
 			proto_tcp.o \
 			proto_udp.o \
@@ -60,6 +63,7 @@
 			tprintf.o \
 			timer.o \
 			mac80211.o \
+			die.o \
 			netsniff-ng.o
 
 ifeq ($(CONFIG_LIBPCAP), 1)
@@ -72,9 +76,9 @@
 netsniff-ng-objs +=	tstamping.o
 endif
 
-netsniff-ng-eflags = $(shell pkg-config --cflags libnl-3.0) \
-		     $(shell pkg-config --cflags libnl-genl-3.0) \
-		     -DHAVE_DISSECTOR_PROTOS -DNEED_TCPDUMP_LIKE_FILTER
+netsniff-ng-eflags = $(shell PKG_CONFIG_PATH=$(PKG_CONFIG_PATH) $(PKG_CONFIG) --cflags libnl-3.0) \
+		     $(shell PKG_CONFIG_PATH=$(PKG_CONFIG_PATH) $(PKG_CONFIG) --cflags libnl-genl-3.0) \
+		     -DNEED_TCPDUMP_LIKE_FILTER
 
 netsniff-ng-confs =	ether.conf \
 			tcp.conf \

=== trafgen/Makefile ===
--- 
+++ 
@@ -1,8 +1,9 @@
-trafgen-libs =	$(shell pkg-config --libs libnl-3.0) \
-		$(shell pkg-config --libs libnl-genl-3.0) \
+trafgen-libs =	$(shell PKG_CONFIG_PATH=$(PKG_CONFIG_PATH) $(PKG_CONFIG) --libs libnl-3.0) \
+		$(shell PKG_CONFIG_PATH=$(PKG_CONFIG_PATH) $(PKG_CONFIG) --libs libnl-genl-3.0) \
 		-lm
 
 trafgen-objs =	xmalloc.o \
+		die.o \
 		ioops.o \
 		privs.o \
 		proc.o \
@@ -24,9 +25,9 @@
 
 trafgen-yaac =	trafgen_parser.tab.o
 
-trafgen-eflags = $(shell pkg-config --cflags libnl-3.0) \
-		 $(shell pkg-config --cflags libnl-genl-3.0) \
-		 -DHAVE_DISSECTOR_PROTOS -I..
+trafgen-eflags = $(shell PKG_CONFIG_PATH=$(PKG_CONFIG_PATH) $(PKG_CONFIG) --cflags libnl-3.0) \
+		 $(shell PKG_CONFIG_PATH=$(PKG_CONFIG_PATH) $(PKG_CONFIG) --cflags libnl-genl-3.0) \
+		 -I..
 
 trafgen-confs =	trafgen_stddef.h

=== debian/changelog ===
netsniff-ng (0.5.9-1) unstable; urgency=low

  * New upstream release:
    + Conditional operator does not typecheck (Closes: #750077)
  * debian/control:
    + Set arch:any (Closes: 749057)
    + Updated Standards-Version to 3.9.6
  * debian/copyright:
    + Updated copyright and fixed wildcard match.

 -- Kartik Mistry <kartik@debian.org>  Sat, 09 May 2015 20:13:45 +0530

=== debian/control ===
--- 
+++ 
@@ -20,13 +20,13 @@
 Maintainer: Daniel Borkmann <daniel.borkmann@alumni.ethz.ch>
 Uploaders: Kartik Mistry <kartik@debian.org>,
            Tobias Klauser <tklauser@distanz.ch>
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Homepage: http://www.netsniff-ng.org/
 Vcs-Git: git://anonscm.debian.org/collab-maint/netsniff-ng.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/netsniff-ng;a=summary
 
 Package: netsniff-ng
-Architecture: amd64 i386 ia64 mips powerpc sparc
+Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Recommends: ntp
 Description: Linux network packet sniffer toolkit
